### Function

# FwupdPlugin xor8_safe

since: 2.1.1

#### Declaration [src]

    gboolean
    fu_xor8_safe (
      const guint8* buf,
      gsize bufsz,
      gsize offset,
      gsize n,
      guint8* value,
      GError** error
    )

#### Description [src]

Returns the bitwise XOR of all bytes in `buf` in a safe way.

You don’t need to use this function in “obviously correct” cases, nor should you use it when performance is a concern. Only use it when you’re not sure if malicious data from a device or firmware could cause memory corruption.

Available since: 2.1.1

#### Parameters

`buf`

  Type: `const guint8*`

  Source buffer.

  The data is owned by the caller of the function.

`bufsz`

  Type: `gsize`

  Maximum size of `buf`, typically `sizeof(buf)`.

`offset`

  Type: `gsize`

  Offset in bytes into `buf` where XOR should start.

`n`

  Type: `gsize`

  Number of bytes to XOR from `buf`.

`value`

  Type: `guint8*`

  The initial value, and result.

  The argument will be modified by the function.
  The argument can be set to `NULL` by the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` if `value` was set, `FALSE` otherwise.